
unit main;

{$IFDEF FPC}{$MODE objfpc}{$H+}{$ENDIF}

interface

uses
  msetypes,
  mseglob,
  mseguiglob,
  mseguiintf,
  mseapplication,
  msestat,
  msemenus,
  msegui,
  msegraphics,
  msegraphutils,
  mseevent,
  mseclasses,
  msewidgets,
  mseforms,
  msesimplewidgets,
  mseimage;

type
  tmainfo = class(tmainform)
    tpaintbox1: tpaintbox;
    timage1: timage;
    timage2: timage;
    procedure mainfo_oncreate(const sender: TObject);
    procedure mainfo_ondestroy(const sender: TObject);
  end;

var
  mainfo: tmainfo;

implementation

uses
  main_mfm,
  msebitmap,
  cairo,
  mseformatpngread;

var
  surface1: pcairo_surface_t;
  context1: pcairo_t;
  image1: imagety;

function cairoimage(aimage: imagety): Pcairo_surface_t; // from msecairo.pas
var
  int1, stridewidth: integer;
  po1: pointer;
  adata: pbyte;
begin
  int1 := aimage.size.cx * aimage.size.cy * 4;
  getmem(adata, int1);
  po1 := pointer(aimage.pixels);
  move(po1^, adata^, int1);
  stridewidth := cairo_format_stride_for_width(CAIRO_FORMAT_RGB24, aimage.size.cx);
  result := cairo_image_surface_create_for_data(adata, CAIRO_FORMAT_RGB24, aimage.size.cx, aimage.size.cy, stridewidth);
end;

procedure tmainfo.mainfo_oncreate(const sender: TObject);
var
  lbitmap: tbitmap;
  lformat: cairo_format_t;
  ldata: pbyte;
  lsize: sizety;
  lstride: integer;
begin
  lsize := makesize(80, 80);

  (*
  lbitmap := tbitmap.create(bmk_rgb);
  lbitmap.size := lsize;
  *)

  (*
  limage.kind := bmk_rgb;
  limage.size := lsize;
  limage.pixels := nil;
  *)

  (*
  ldata := pbyte(image1.pixels);
  lformat := CAIRO_FORMAT_ARGB32;
  lstride := cairo_format_stride_for_width(lformat, image1.size.cx);

  surface := cairo_image_surface_create_for_data(
    ldata,
    lformat,
    lsize.cx,
    lsize.cy,
    lstride
  );
  *)

  allocimage(image1, lsize, bmk_rgb);

  surface1 := cairoimage(image1);
  context1 := cairo_create(surface1);
  
  // a red square
  cairo_set_source_rgb(context1, 1.0, 0.0, 0.0);
  cairo_paint(context1);

  cairo_destroy(context1);
  cairo_surface_write_to_png(surface1, pchar('surface1.png'));
  cairo_surface_destroy(surface1);

  timage1.bitmap.loadfromimage(image1);
  //timage1.invalidate;

  timage2.bitmap.loadfromfile('eschecs80x80.png');
  //timage2.invalidate;
end;

procedure tmainfo.mainfo_ondestroy(const sender: TObject);
begin
  freeimage(image1);
end;

end.
